﻿class Jeu {
	#include "Constantes.as"

	private var main:MovieClip;
	private var soundtrack:Sound;
	private var joueur;
	private var troncon;
	private var circuit;
	private var segments:Array;
	private var frameAvancer;
	private var frameTouches;
	private var finDePartie:Boolean;
	private var bonneFinDePartie:Boolean;
	private var position;
	private var dejaVu:Array;
	private var arret:Boolean;
	private var messageClip:MovieClip;
	private var vitesseMax:Number;
	private var reemission:Boolean;
	
	public function Jeu() {
		var i;
		position = 0;
		dejaVu = [];
		dejaVu[DV_REPETITEUR] = false;
		dejaVu[DV_IMPURETE] = false;
		dejaVu[DV_TCP] = false;
		dejaVu[DV_UDP] = false;
		dejaVu[DV_PERFECT] = false;
		finDePartie = false;
		bonneFinDePartie = false;
		arret = false;
		frameAvancer = 0;
		frameTouches = 0;
		vitesseMax = VMAX;
		reemission = false;
		joueur = new Joueur(0, IDEFAUT, VDEFAUT);
		troncon = new Troncon(NBCERCLES, TR_STANDARD, 0, 0, 0, 0, 0);
		circuit = new Circuit(DISTREPETDEFAUT,LONGCIRCUITDEFAUT,0.4);
		segments=[];
		for (i = 0; i < NBCERCLES; i++) {
			segments[i] = new Segment((i+1)*NBPOSITIONS,troncon,i+1,"S" + i);
		}
		main = _root.attachMovie("Interface","I",DEPTHMAX-1);
		main._x = Stage.width/2;
		main._y = Stage.height/2;
		messageClip = main.attachMovie("Message","M",DEPTHMAX);
		messageClip._visible = false;
		soundtrack = new Sound();
		soundtrack.attachSound("Soundtrack");
		soundtrack.start(3, 42);
		main.protocolText.text = "Protocol: UDP";
	}
	
	private function AfficherAide(aide:String) {
		arret = true;
		messageClip._visible = true;
		messageClip.messageText.text = aide;
	}

	private function SegmentSuivant() {
		var temp = segments[0].clip._name;
		var i;
		segments[0].DetruireClip();
		delete segments[0];
		for (i = 0; i < NBCERCLES - 1; i++) {
			segments[i] = segments[i+1];
		}
		circuit.distanceParcourue++;
		if (troncon.posCourante < troncon.longueur) {
			segments[NBCERCLES-1] = troncon.NouveauSegment(ZMAX+1, temp);
		} else {
			if (circuit.dernierTroncon) {
				AfficherAide("Congratulations. The file has been received.");
				bonneFinDePartie = true;
			} else {
				troncon = circuit.NouveauTroncon();
				segments[NBCERCLES-1] = troncon.NouveauSegment(ZMAX+1, temp);
			}
			
		}
		if (!dejaVu[DV_IMPURETE])
			for (i in segments[NBCERCLES-1].objets)
				if (segments[NBCERCLES-1].objets[i].type == OBJ_IMPURETE) {
					dejaVu[DV_IMPURETE] = true;
					AfficherAide(DV_IMPURETE_TEXTE);
				}
		if (!dejaVu[DV_TCP])
			for (i in segments[NBCERCLES-1].objets)
				if (segments[NBCERCLES-1].objets[i].type == OBJ_TCP) {
					dejaVu[DV_TCP] = true;
					AfficherAide(DV_TCP_TEXTE);
				}
		if (!dejaVu[DV_UDP])
			for (i in segments[NBCERCLES-1].objets)
				if (segments[NBCERCLES-1].objets[i].type == OBJ_UDP) {
					dejaVu[DV_UDP] = true;
					AfficherAide(DV_UDP_TEXTE);
				}
		if (!dejaVu[DV_PERFECT])
			for (i in segments[NBCERCLES-1].objets)
				if (segments[NBCERCLES-1].objets[i].type == OBJ_FIBREPARFAITE) {
					dejaVu[DV_PERFECT] = true;
					AfficherAide(DV_PERFECT_TEXTE);
				}
	}
	

	private function Avancer() {
		if(frameAvancer < 4 / joueur.vitesse) {
			frameAvancer++;
			return;
		}
		frameAvancer = 0;
		
		var i;
		if ( position == NBPOSITIONS - 1 ) {
			SegmentSuivant();
			position = 0;
		} else {
			position++;
		}
		for (i = 0; i < NBCERCLES; i++) {
			segments[i].Defiler();
		}
		Objets();
	}
	
	private function Objets() {
		var i;
		if(segments[0].troncon.type == TR_REPETITEUR) {
			if (!dejaVu[DV_REPETITEUR] and !finDePartie) {
				AfficherAide(DV_REPETITEUR_TEXTE);
				dejaVu[DV_REPETITEUR] = true;
			}
			joueur.intensite = IDEFAUT;			
		}
		for (i in segments[0].objets) {
			//Si l'objet est sur le même plan que la boule
			if (segments[0].z == ZJOUEUR && segments[0].objets[i] != 0)  {
			//Si l'objet est au même endroit que la boule
				if (Math.abs(segments[0].objets[i].angle - joueur.angle) <  segments[0].objets[i].rayon
					|| Math.abs(segments[0].objets[i].angle - joueur.angle) > 360 - segments[0].objets[i].rayon) {
						switch(segments[0].objets[i].type) {
							case OBJ_IMPURETE:
								joueur.intensite += ICOLLISION;
								joueur.vitesse += VCOLLISION;
								if(joueur.vitesse < VMIN)
									joueur.vitesse = VMIN;
								joueur.Collision();
							break;
							case OBJ_TCP:
								main.protocolText.text = "Protocol: TCP"+newline+"1 reconnection attempt left";
								vitesseMax = 0.75 * VMAX;
								if (joueur.vitesse > vitesseMax)
									joueur.vitesse = vitesseMax;
								reemission = true;
							break;
							case OBJ_UDP:
								main.protocolText.text = "Protocol: UDP";
								vitesseMax = VMAX;
								reemission = false;
							break;
							case OBJ_FIBREPARFAITE:
								circuit.tronconsParfaits += 5;
							break;
						}
				}
			}
		}
	}
	
	private function Touches() {
		
		if(frameTouches < 5) {
			frameTouches++;
			return;
		}
		frameTouches = 0;
		
		if (!finDePartie && !arret) {
			if (joueur.vitesseAngulaire > 0) {
				joueur.vitesseAngulaire -= VROTFRICTION;
			} else if (joueur.vitesseAngulaire < 0) {
				joueur.vitesseAngulaire += VROTFRICTION;
			}
			if (Key.isDown(Key.LEFT)) {
				joueur.vitesseAngulaire = VROTMAX;
			} else if (Key.isDown(Key.RIGHT)) {
				joueur.vitesseAngulaire = -VROTMAX;
			}
			if (joueur.vitesseAngulaire > VROTMAX) {
				joueur.vitesseAngulaire = VROTMAX;
			} else if (joueur.vitesseAngulaire < -VROTMAX) {
				joueur.vitesseAngulaire = -VROTMAX;
			}
			joueur.angle += joueur.vitesseAngulaire;
			if (joueur.angle < 0)
				joueur.angle += 360;
			else if (joueur.angle > 360)
				joueur.angle -= 360;
			
			if (Key.isDown(Key.UP)) {
					joueur.vitesse += 0.01;
			} else if (Key.isDown(Key.DOWN)) {
					joueur.vitesse -= 0.01;
			} else {
					joueur.vitesse -= 0.005;
			}
			if (joueur.vitesse < VMIN)
				joueur.vitesse = VMIN;
			else if (joueur.vitesse > vitesseMax)
				joueur.vitesse = vitesseMax;
				
		} else if (arret) {
			
			if (Key.isDown(Key.ESCAPE)) {
				messageClip._visible = false;
				arret = false;
			}
	
		} 
		if (finDePartie) {
			
			if (Key.isDown(Key.ESCAPE)) {
				arret = true;
				for (var i in _root) {
					if (typeof(_root[i]) == "movieclip") {
						_root[i].removeMovieClip();
					}
				}
				soundtrack.stop();
				_root.gotoAndStop(3415);				
			}
		}
		if (bonneFinDePartie) {
			if (Key.isDown(Key.ESCAPE)) {
				arret = true;
				for (var i in _root) {
					if (typeof(_root[i]) == "movieclip") {
						_root[i].removeMovieClip();
					}
				}
				soundtrack.stop();
				_root.gotoAndPlay(3438);				
			}
		}
	}
	
	private function PerdreIntensite() {
		joueur.intensite += IPERTE;
		if (joueur.intensite <= 0) {
			if (reemission) {
				reemission = false;
				joueur.intensite = IDEFAUT;
				main.protocolText.text = "Protocol: TCP";				
			} else {
				finDePartie = true;
				joueur.intensite = 0;
				AfficherAide("Connection failed." + newline + "The signal lost too much of its intensity and there were no more TCP reconnection attempts left.");
			}
		}
	}

	public function Refresh() {
		Touches();
		if (!arret) {
			Avancer();
			PerdreIntensite();
			joueur.Redessiner();
		}
	}

}