﻿class Joueur {
	#include "Constantes.as"
	
	public var angle;
	public var intensite;
	public var vitesse;
	public var vitesseAngulaire;
	public var clip:MovieClip;
	
	public function Joueur(angle:Number, intensite:Number, vitesse:Number) {
		this.angle = angle;
		this.intensite = intensite;
		this.vitesse = vitesse;
		this.vitesseAngulaire = 0;
		clip = _root.attachMovie("Joueur","J",DEPTHMAX-2);
		clip._x = Stage.width/2;
		clip._y = Stage.height/2;
		clip._rotation = angle;
		Redessiner();
	}

	public function Redessiner() {
		clip.transform.colorTransform = TeinteVersRGB(vitesse);
		clip._rotation = angle;
		clip.boule._xscale = BASETAILLE + 100 * intensite;
		clip.boule._yscale = BASETAILLE + 100 * intensite;
	}
	
	private function TeinteVersRGB(teinte:Number):flash.geom.ColorTransform {
		var couleur = new flash.geom.ColorTransform;
		
		if(teinte < 0.2) {
			couleur.redMultiplier = 1;
			couleur.greenMultiplier = teinte * 5;
			couleur.blueMultiplier = 0;
		} else if(teinte < 0.4) {
			couleur.redMultiplier = (0.4 - teinte) * 5;
			couleur.greenMultiplier = 1;
			couleur.blueMultiplier = 0;			
		} else if(teinte < 0.6) {
			couleur.redMultiplier = 0;
			couleur.greenMultiplier = 1;
			couleur.blueMultiplier = (teinte - 0.4) * 5;
		} else if(teinte < 0.8) {
			couleur.redMultiplier = 0;
			couleur.greenMultiplier = (0.8 - teinte) * 5;
			couleur.blueMultiplier = 1;
		} else {
			couleur.redMultiplier = (teinte - 0.8) * 5;
			couleur.greenMultiplier = 0;
			couleur.blueMultiplier = 1;
		}
		
		return couleur;
	}
	
	public function Collision() {
		clip.boule.play();
	}
}