﻿class Segment {
	#include "Constantes.as"
	
	public var troncon;
	public var z:Number;
	public var posTroncon:Number;
	public var clip:MovieClip;
	public var objets:Array;
	
	private function Redessiner() {
		var A:Number;
		clip._xscale = 100/z;
		clip._yscale = 100/z;
		if ( posTroncon < troncon.longueur/2) {
			A = posTroncon;
		} else {
			A = (troncon.longueur - posTroncon) / 2;
		}
		clip._x = Stage.width/2 + (z/(ZMAX-1) * A ) * troncon.courbure * Math.cos(troncon.theta);
		clip._y = Stage.height/2 + (z/(ZMAX-1) * A ) * troncon.courbure * Math.sin(troncon.theta);
	}

	public function DetruireClip() {
		clip.removeMovieClip();
	}
	
	public function Segment(z:Number,troncon:Troncon,posTroncon:Number,nom:String) {
		var i;
		var obj;
		this.troncon = troncon;
		this.z = z;
		this.posTroncon = posTroncon;
		clip = _root.attachMovie("Segment",nom, DEPTHMAX - z*DEPTHPARZ);
		switch(troncon.type) {
			case TR_STANDARD:
			case TR_PARFAIT:
				clip.attachMovie("AnneauStandard", "anneau", 0);
				break;
			case TR_REPETITEUR:
				clip.attachMovie("AnneauRepetiteur", "anneau", 0);
				break;
		}
		clip.anneau.transform.colorTransform = troncon.couleur;
		Redessiner();
		objets = [];
		for (i = 0; i < NBOBJMAX; i++) {
			for (obj = 1; obj < OBJ_MAX; obj++) {
				if (Math.random() < troncon.probaObjets[obj]) {
					objets[i] = new Objet(i, z, "O"+i+nom, this, obj);
					break;
				}
			}
		}
	}

	public function Defiler() {
		z--;
		if (z != 0) {
			clip.swapDepths(DEPTHMAX - z*DEPTHPARZ);
			Redessiner();
		}
	}
}